<template>
  <div v-if="data">
    <div class="event-header">
      <MainContainer class="container">
        <div class="single-grid space-between">
          <div class="col-8">
            <Information :date="data.created_at" :location="data.location" />
          </div>
          <div class="col-4 self-end hide-mobile">
            <div style="display: flex; align-items: center; font-size: 0">
              <nuxt-link
                v-if="currentUser && currentUser.id === data.user.id"
                :to="localePath(`/profile/photography/${type}s/${data.id}`)"
                ><svg-icon
                  style="
                    margin-right: 30px;
                    width: 30px;
                    height: 30px;
                    fill: #00ffb3;
                  "
                  name="setting"
              /></nuxt-link>
              <Burger />
            </div>
          </div>
        </div>
        <div class="single-grid space-between" style="align-items: flex-end">
          <div class="col-8">
            <div v-if="data.name" class="event-header__title">
              {{ data.name }}
            </div>
            <div v-if="data.comment" class="event-header__description">
              {{ data.comment }}
            </div>

            <Clients :customer="data.customer" :author="data.user" />
            <div v-if="data.tags && type == 'album'" class="single-tags">
              <div v-for="(item, index) in data.tags" :key="index">
                <span>{{ item.tag.tag }}</span>
              </div>
            </div>
          </div>
          <div class="col-4 self-end">
            <Payment :payment="data.payment_types" />
          </div>
        </div>
      </MainContainer>
      <div v-if="data.cover" class="event-header__bg">
        <client-only>
          <blur-hash-image
            v-if="data.cover.blurhash"
            class="blurhash"
            :hash="data.cover.blurhash"
            :src="`/storage/${data.cover.preview_url}`"
          />
          <img v-else :src="`/storage/${data.cover.preview_url}`" alt="" />
        </client-only>
      </div>
    </div>
    <div class="event-section">
      <MainContainer class="container">
        <Feed :data="media" variant="large" :counter="true" />
      </MainContainer>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, computed } from '@nuxtjs/composition-api'
import { useMediaSubscription } from '@/sdk/hooks'
import { MediaFileFragment } from '@/sdk/types'

import useSidebarMenu from '@/hooks/sidebar-menu'
import Burger from '@/components/ui/Burger.vue'
import Payment from '@/components/ui/Payment.vue'
import Clients from '@/components/ui/Clients.vue'
import Information from '@/components/ui/Information.vue'
import Feed from '@/components/ui/Feed.vue'
import MainContainer from '@/components/ui/MainContainer.vue'

export default defineComponent<{
  data: any
  type: string
}>({
  layout: 'single',
  name: 'PublicPage',
  components: { Burger, Payment, Clients, Information, Feed, MainContainer },
  props: ['data', 'type'],
  head: {},
  setup(props, { root }) {
    const { toggleSidebarMenu } = useSidebarMenu()
    const currentUser = computed(() => root.$accessor.auth.user)
    const index = null
    const gallery = () => {
      return props.data.media_files.map(function (item: any) {
        return {
          src: `/storage/${item.preview_url}`
        }
      })
    }

    // upload photos && output media
    const pageSize = ref(100)
    const media = ref<MediaFileFragment[]>([])
    const { onResult: mediaResult } = useMediaSubscription(
      props.type === 'event'
        ? computed(() => ({
            where: {
              event_id: { _eq: props.data.id }
            },
            limit: pageSize.value,
            offset: 0
          }))
        : computed(() => ({
            where: {
              album_id: { _eq: props.data.id }
            },
            limit: pageSize.value,
            offset: 0
          }))
    )
    mediaResult(result => {
      if (result?.data?.media_files) {
        media.value = result.data.media_files
      }
    })

    return {
      currentUser,
      toggleSidebarMenu,
      index,
      media,
      gallery
    }
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/page-albums';

.event-header {
  padding-top: 30px;
  padding-bottom: 30px;
  position: relative;
  z-index: 2;
  @media (min-width: 1199.98px) {
    padding-top: 70px;
    padding-bottom: 70px;
  }
  .container {
    padding-left: 30px;
    padding-right: 30px;
    @media (min-width: 991.98px) {
      min-height: 500px;
      display: flex;
      flex-direction: column;
      justify-content: space-between;
      padding-left: 85px;
      padding-right: 85px;
    }
  }

  &__bg {
    position: absolute;
    left: 0;
    right: 0px;
    top: 0px;
    bottom: 0px;
    z-index: -1;
    opacity: 0.3;
    pointer-events: none;
    overflow: hidden;
    display: flex;
    ::v-deep {
      .blurhash {
        flex: 1;
        display: flex;
        padding: 0 !important;
        img {
          object-fit: cover;
        }
      }
    }
    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }

  &__title {
    font-weight: 300;
    font-size: 40px;
    line-height: 47px;
    color: #ffffff;
    margin-bottom: 40px;
    letter-spacing: -1px;
    @media (min-width: 1199.98px) {
      font-size: 55px;
      line-height: 55px;
    }
  }
  &__description {
    font-size: 24px;
    line-height: 30px;
    color: #ffffff;
    margin-top: -25px;
    margin-bottom: 40px;
    font-weight: 300;
    @media (min-width: 1199.98px) {
      font-size: 24px;
      line-height: 36px;
    }
  }

  ::v-deep {
    .information > div div {
      color: #ffffff;
    }
  }
}

.event-section {
  padding-top: 30px;
  padding-bottom: 30px;
  @media (min-width: 1199.98px) {
    padding-top: 30px;
    padding-bottom: 100px;
  }
  .container {
    padding-left: 30px;
    padding-right: 30px;
    @media (min-width: 991.98px) {
      padding-left: 85px;
      padding-right: 85px;
    }
  }
}
</style>
